<template>
  <div class="add_wordshop">
    <el-dialog
      :title="editConfig.dialogTitle+'车间管理'"
      :visible.sync="editConfig.visible"
      width="30%"
      :before-close="handleClose">
      <el-form :inline="true" label-width="20%" style="width: 100%;" :model="editConfig.infomitton" :rules="rules" ref="ruleForm" >
        <el-form-item prop="workshop"  label="车间" style="width: 100%;" >
          <el-select 
            :disabled="this.editConfig.dialogTitle==='查看'" v-model="editConfig.infomitton.workshop" value-key="name" placeholder="请选择车间">
            <el-option
              v-for="item in workshopList"
              :key="item.ID"
              :label="item.name"
              :value="item">
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="组别" style="width: 100%;" 
            prop="groupNumber"  >
          <!-- <el-input-number
            v-model="form.workshop"
            placeholder="请输入组别"
            :controls="false"
            style="width: 100%; margin-right: 5px;text-align:left;"
          ></el-input-number> -->
          <el-input
            :disabled="this.editConfig.dialogTitle==='查看'"
            v-model="editConfig.infomitton.groupNumber"
            :rows="4"
            style="resize: none !important;"
            placeholder="请输入组别"
            >
          </el-input>
        </el-form-item>
        
        <el-form-item label="开始车号" style="width: 100%;" >
          <el-input
            :disabled="this.editConfig.dialogTitle==='查看'"
            v-model="editConfig.infomitton.startCarNumber"
            :rows="4"
            style="resize: none !important;"
            placeholder="请输入开始车号"
            >
          </el-input>
        </el-form-item>
        <el-form-item label="结束车号" style="width: 100%;" >
          <el-input
            :disabled="this.editConfig.dialogTitle==='查看'"
            v-model="editConfig.infomitton.endCarNumber"
            :rows="4"
            style="resize: none !important;"
            placeholder="请输入结束车号"
            >
          </el-input>
        </el-form-item>
        <el-form-item label="半车标志" style="width: 100%;" >
          <el-select 
            :disabled="this.editConfig.dialogTitle==='查看'" v-model="editConfig.infomitton.carFlag" placeholder="请选择半车标志">
            <el-option
              v-for="item in carFlagList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" style="width: 100%;" >
          <el-input
            :disabled="this.editConfig.dialogTitle==='查看'"
            v-model="editConfig.infomitton.notes"
            type="textarea"
            :rows="4"
            style="resize: none !important;"
            placeholder=""
            >
          </el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="editConfig.visible = false">取 消</el-button>
        <el-button type="primary" @click="commitForm('ruleForm')">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import {getDict,saveWorkshopManage} from "@/api/systemSetting/workshopManage"
export default {
  props: {
    editDiaConfig:{
      type: Object,
      default: () => {
        return {
          visible: false,
          dialogTitle:"添加",
          isReadonly:true,
          infomitton: {
          },
        }
      }
    }
  },
  data() {
    return {
      editConfig:this.editDiaConfig,
      workshopList:[],
      carFlagList:[
        {id:1,name:"左半车"},
        {id:2,name:"右半车"},
        {id:3,name:"全车结束"},
      ],
      rules: {
        workshop: [
          { required: true, message: '请选择车间', trigger: 'change' }
        ],
        groupNumber: [
          { required: true, message: '请填写组别', trigger: 'change' }
        ]
      },
    };
  },
  computed: {
  },
  created() {
    this.getDictData()
  },
  mounted() {

  },
  watch: {

  },
  methods: {
    handleClose(done) {
      done();
    },
    async getDictData(){
      await getDict({dictType:1}).then((res)=>{
        if(res&&res.code===200){
          this.workshopList=res.data
        }
      })
    },
    setParams(){
      let params={
        workshopNumber:this.editConfig.infomitton.workshop.number+"",
        workshopName:this.editConfig.infomitton.workshop.name,
        groupNumber:Number(this.editConfig.infomitton.groupNumber),
        startCarNumber:Number(this.editConfig.infomitton.startCarNumber),
        endCarNumber:Number(this.editConfig.infomitton.endCarNumber),
        carFlag:Number(this.editConfig.infomitton.carFlag),
        notes:this.editConfig.infomitton.notes,
      }
      return params
    },
    async commitForm(formName){
      this.$refs[formName].validate((valid) => {
        if (valid) {
          let params=this.setParams()
          if(this.editConfig.dialogTitle==="新增"){
            saveWorkshopManage(params).then((res)=>{
              if(res&&res.code===200){
                this.editConfig.visible=false
                this.$message({
                  message: "保存成功!",
                  type: "success",
                });
                this.$parent.getData()
              }
            })
          }else if(this.editConfig.dialogTitle==="修改"){
            saveWorkshopManage({
              ...params,
              id:this.editConfig.infomitton.ID
            }).then((res)=>{
              if(res&&res.code===200){
                this.editConfig.visible=false
                this.$message({
                  message: "保存成功!",
                  type: "success",
                });
                this.$parent.getData()
              }
            })
          }
        } else {
          console.log('error submit!!');
          return false;
        }
      });


    }
  },
  components: {

  },
};
</script>

<style scoped lang="scss">
::v-deep .el-form-item__content{
  width: 70% !important;
}
::v-deep{
  .el-form{
    .el-input__inner {  
      text-align: left;  
    }
  }
  .el-select{
    width: 100%;
  }
}
</style>
